use crate::{errors::RunError, stack::StackVec};
use std::io::Read;

pub fn putc(memory: &mut StackVec) {
    print!("{}", memory.pop() as u8 as char);
}

pub fn getc(memory: &mut StackVec) {
    let char = std::io::stdin()
        .bytes()
        .next()
        .and_then(|result| result.ok())
        .map(|byte| byte as u16)
        .expect(&format!("{}", RunError::FailToGetCharFromConsole));

    memory.push(char);
}

pub fn scan(memory: &mut StackVec) {
    let mut input = String::new();

    std::io::stdin()
        .read_line(&mut input)
        .expect(&format!("{}", RunError::FailToReadLineFromConsole));

    let num = input
        .trim()
        .parse()
        .expect(&format!("{}", RunError::InvalidInputUShortInt));
    memory.push(num);
}

pub fn meow(memory: &mut StackVec) {
    println!("{}", memory.pop());
}

pub fn print(arg: String) {
    print!("{}", arg);
}

pub fn println(arg: String) {
    println!("{}", arg);
}
