use crate::{errors::RunError, stack::StackVec};
use fastrand;

pub fn random(memory: &mut StackVec) {
    let data = memory.pop();
    memory.push(fastrand::u16(..) % (data - 1));
}

pub fn rjmp(memory: &mut StackVec, labels: &mut [Option<i16>; 256], program_counter: &mut u16) {
    let start = memory.pop() as usize;
    let end = memory.pop() as usize;
    let rand = fastrand::usize(start..end + 1);

    *program_counter =
        (labels[rand].expect(&format!("{}", RunError::UnknownLabel(rand as u16))) - 1) as u16;
}
